var win = Ti.UI.currentWindow;

function Window(name, createNavGroup, navBarHidden) 
{
    this.name = name;
    this.url = '/window/' + name + '.js';
     
    this.win = null;
    this.createNavGroup = createNavGroup;
    this.navGroup = null;
    this.parentNavGroup = null;
    this.parentWin = null;
    this.parentTabGroup = null;
   
   // this.navBarHidden = navBarHidden;
  
    var self = this; 
     
       this.init = function() {
    	//Ti.API.debug("Creating window: " + self.name);
        
        self.initDefaults();
          
        self.win = Ti.UI.createWindow({
           id: self.name,
           url: self.url,
           className: 'window',
           backgroundColor: '#ffffff',
           navBarHidden : (self.navBarHidden) ? self.navBarHidden : false,
           title: "",
           parentWin: win ? win : null
        });
         
        Ti.API.info("Creating nav group");
        self.navGroup = Ti.UI.iPhone.createNavigationGroup({
            window: self.win
        });
        
        if(self.parentNavGroup) {
        	Ti.API.info(">>> Setting win nav group (parent)");
            self.win.parentNavGroup = self.parentNavGroup;
        }
        else if(self.navGroup) {
        	Ti.API.info(">>> Setting win nav group"  + self.navGroup);
            self.win.parentNavGroup = self.navGroup;
        }
         
        if(self.parentTabGroup) {
        	//Ti.API.info(">>> Setting win tab group"  +  self.parentTabGroup);
            self.win.parentTabGroup = self.parentTabGroup;
        }
    };
     
   
    this.initDefaults = function() {
        if(self.createNavGroup == undefined) {
            self.createNavGroup = false;
        }
            
        if(win != undefined) {
        	if(win.parentNavGroup != undefined) {
            	Ti.API.info(">>> Setting parent nav group");
                self.parentNavGroup = win.parentNavGroup;
            }
             
            if(win.parentTabGroup) {
            	//Ti.API.info(">>> Setting parent tab group");
                self.parentTabGroup = win.parentTabGroup;
            }
        }
    };
     
    /**
     * disable the back button
     */
   
   // this.disableBackButton = function() {
     //   self.win.setLeftNavButton(Ti.UI.createView({}));
    //};
     
       this.setBackButtonTitle = function(title) {
        self.win.backButtonTitle = title;
    };
     
        this.setTabBarHidden = function(hidden) {
        self.win.tabBarHidden = hidden;
    };
     
       this.getTiWin = function() {
        return self.win;
    };
     
    
    this.open = function(modal) {
        if(modal == undefined) {
            modal = false;
        }
         
        if(self.parentTabGroup) {
        	Ti.API.info("Opening current tab group (Create): " + self.name);
            Ti.UI.currentTab.open(this.getTiWin());
        }
        else if(self.parentNavGroup) {
            Ti.API.info("Opening nav group (Normal): " + self.name);            
            self.parentNavGroup.open(self.win);
        }
        else if(self.navGroup) {
            Ti.API.info("Opening nav group (Create): " + self.name);
            
            var parentWin = Ti.UI.createWindow({
               id: "parentWin",
               className: 'window'
            });
             
            self.win.parentWin = parentWin;
             
            parentWin.open();
             
            parentWin.add(self.navGroup);  
        }
        else {
        	
            if(modal) {
                Ti.API.info("Opening normal window (Modal): " + self.name);
                self.win.open({
                    modal: modal,
                    modalStyle: Ti.UI.iPhone.MODAL_PRESENTATION_FORMSHEET
                });
            }
            else {
                Ti.API.info("Opening normal window (Non Modal): " + self.name);
                self.win.open();
            }
        }      
    };
     
    self.init();
}